import "misc.m": ProcessPresentation; 

Group6_178 := function (p: Process:=true, Select:=func<x|true>)

if p lt 5 then "6.178 valid only for p>3"; return false; end if;

class:=4;

w:=0;
F:=FiniteField(p);
for i in [2..p-1] do
a:=F!i;
S:={a};
for j in [2..p-1] do
  Include(~S,a^j);
end for;
if #S eq p-1 then
  w:=i;
  break;
end if;
end for;
vprint Orderp7, 2:"p equals",p;
vprint Orderp7, 2:"w equals",w;

/*
Baker-Campbell-Hausdorff applied to
  <a,b,c|ca-bab,cb-wbaa,pa-xbaa-ybab,pb-zbaa+xbab,pc,class=4>
gives:

(b,a,a,a)^x*(b,a,a,b)^y = 1
(b,a,a,b)^z = (b,a,b,b)^x
(b,a,a,a)^z*(b,a,b,b)^y = 1

L^4 is generated by baaa unless y=0, in which case L^4 is generated by baab

GR:=Group<a,b,c | (c,a)*(b,a,b)^-1*(b,a,b,b), (c,b)*(b,a,a)^-w*(b,a,a,a)^w, 
a^p*(b,a,a)^-x*(b,a,b)^-y*(b,a,a,a)^x*(b,a,a,b)^(1/2*x+1/2*y)*(b,a,b,b)^y, 
b^p*(b,a,a)^-z*(b,a,b)^x*(b,a,a,a)^z*(b,a,a,b)^(-1/2*x+1/2*z)*(b,a,b,b)^-x, 
c^p>;

*/

SQ:={};
for i in [0..((p-1) div 2)] do
  Include(~SQ,i^2 mod p);
end for;

Z:=Integers();
V1:=VectorSpace(F,1);
V2:=VectorSpace(F,2);
H22:=Hom(V2,V2);

L:=[]; Nmr := 0;

count:=0;
mats:=[];

for y1 in [0,1] do
for y2 in [0..p-1] do
for y3 in [0..p-1] do
y4:=(p-y1) mod p;

A:=H22![y1,y2,y3,y4];
if Rank(A) lt 2 then continue; end if;

new:=1;
index:=p^2*y1+p*y2+y3;

for a in [0..p-1] do
for b in [0..p-1] do
if a+b eq 0 then continue; end if;
for c in [1,-1] do

P:=H22![a,b,w*b*c,a*c];
C:=F!(c*(a^2-w*b^2));

D:=P*A*P^-1*C^-1;

z1:=Z!(D[1][1]);
z2:=Z!(D[1][2]);
z3:=Z!(D[2][1]);

ind1:=p^2*z1+p*z2+z3;

if ind1 lt index then new:=0; break; end if;

end for;
if new eq 0 then break; end if;
end for;
if new eq 0 then break; end if;
end for;

if new eq 1 then
  count:=count+1;
  //print y1,y2,y3,y4;
  Append(~mats,A);
end if;

end for;
end for;
end for;

//print count,(3*p-1)/2;

count:=0;

for A in mats do
x:=Z!(A[1][1]);
y:=Z!(A[1][2]);
z:=Z!(A[2][1]);

r:=(F!(x+y))*(F!2)^-1; r:=Z!r;
s:=(F!(z-x))*(F!2)^-1; s:=Z!s;

u:=F!((x^2+y*z)*(2*(w*y+z)^2+w*(x^2+y*z))); u:=Z!u;
v:=F!((z-w*y)^2-4*w*x^2); v:=Z!v;

if x eq 0 and y eq 1 and z eq w then
  for t in [0..((p-1) div 2)] do
    count:=count+1;
    GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
        (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
         b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=f^t>;
    ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
    //tail on pa,pb zero, tail on pc equals tbaaa
  end for;
end if;

if x eq 1 and y eq 0 and z eq 0 then
  range:=[0..((p-1) div 2)];
  if p mod 4 eq 3 then print "Arghhh!!!"; end if;
  if p mod 4 eq 3 then range:=[0..p-1]; end if;
  for t in range do
    count:=count+1;
    GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
         (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
         b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=g^t>;
    ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
    //tail on pa,pb zero, tail on pc equals tbaab
  end for;
end if;

if y ne 0 and (w*y+z) mod p eq 0 then    
  for t in [0..((p-1) div 2)] do
    count:=count+1;
    GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
         (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
         b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=f^t>;
    ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
    //tail on pa,pb zero, tail on pc equals tbaaa
  end for;
end if;

if x eq 0 and z ne (w*y) mod p and z ne (w*(p-y)) mod p then
  for t in [0..((p-1) div 2)] do
    count:=count+1;
    GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
         (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
         b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=f^t>;
    ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
    //tail on pa,pb zero, tail on pc equals tbaaa
  end for;
  if u eq 0 then
    if (w*y+2*z) mod p eq 0 then
      for t in [1..((p-1) div 2)] do
        count:=count+1;
        GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
           (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-(x-t)*g^-r*h^-y, 
           b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p>;
        ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
        //tail on pb,pc zero, tail on pa equals tbaaa
      end for;
    end if;
    if (2*w*y+z) mod p eq 0 then
      for t in [1..((p-1) div 2)] do
        count:=count+1;
        GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
             (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
              b^p=d^z*e^-x*f^-(z-t)*g^-s*h^x, c^p>;
        ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
        //tail on pa,pc zero, tail on pb equals tbaaa
      end for;
    end if;
  end if;
  if u ne 0 and u in SQ then
    u1:=F!(u)*(F!y)^-2; u1:=Z!u1;
    //find value of t such that u=t^2
    for t in [1..((p-1) div 2)] do
      if t^2 mod p eq u1 then val:=t; break; end if;
    end for;
    for t in [1..((p-1) div 2)] do
      count:=count+1;
      GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
               (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
                b^p=d^z*e^-x*f^-(z-t)*g^-s*h^x, c^p=f^val>;
      ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
      //tail on pa zero, tail on pb equals tbaaa, tail on pc equals valbaaa
    end for;
  end if;
end if;

if x eq 1 and (z+w*y) mod p ne 0 then
  for t in [0..p-1] do
    count:=count+1;
    GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
              (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
               b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=g^t>;
    ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
    //tails on pa,pb zero, tail on pc is tbaab
  end for;
  if u eq 0 then print "Arghhh!!!!!"; end if;
  if u in SQ then
    //find t such that u=t^2
    for t in [1..p-1] do
      if t^2 mod p eq u then val:=t; break; end if;
    end for;
    if F!(-w*y-z+val) eq 0 and F!(-w*y^2-2*y*z-1) eq 0 then
      for t in [1..((p-1) div 2)] do
        count:=count+1;
        GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
                  (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-(r-t)*h^-y, 
                   b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=g^val>;
        ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
        //tail on pa is tbaab, tail on pb is 0, tail on pc is val.baab
      end for;
    else;
      for t in [1..((p-1) div 2)] do
        count:=count+1;
        GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
                  (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
                   b^p=d^z*e^-x*f^-z*g^-(s-t)*h^x, c^p=g^val>;
        ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
        //tail on pa is 0, tail on pb is tbaab, tail on pc is val.baab
      end for;
    end if;
    if F!(-w*y-z-val) eq 0 and F!(-w*y^2-2*y*z-1) eq 0 then
      for t in [1..((p-1) div 2)] do
        count:=count+1;
        GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
                  (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-(r-t)*h^-y, 
                   b^p=d^z*e^-x*f^-z*g^-s*h^x, c^p=g^-val>;
        ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
        //tail on pa is tbaab, tail on pb is 0, tail on pc is -val.baab
      end for;
    else;
      for t in [1..((p-1) div 2)] do
        count:=count+1;
        GR:=Group<a,b,c,d,e,f,g,h|d=(b,a,a),e=(b,a,b),f=(d,a),g=(d,b),h=(e,b),
                   (c,a)=e*h^-1, (c,b)=d^w*f^-w, a^p=d^x*e^y*f^-x*g^-r*h^-y, 
                    b^p=d^z*e^-x*f^-z*g^-(s-t)*h^x, c^p=g^-val>;
        ProcessPresentation (~L, GR, p, class, ~Nmr: Process := Process, Select := Select);
        //tail on pa is 0, tail on pb is tbaab, tail on pc is -val.baab
      end for;
    end if;
  end if;
end if;

end for;

vprint Orderp7, 1: "Group 6.178 has",count,"descendants of order p^7 and p-class 4";

vprint Orderp7, 2: "Total number of groups is (3p^2-1)/2 =",(3*p^2-1)/2;

if Process then return Nmr; else return L; end if;

end function;
